"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var cropperjs_1 = __importDefault(require("cropperjs"));
require("cropperjs/dist/cropper.css");
require("../static/css/simple-react-cropper.css");
var dummy_png_1 = __importDefault(require("../static/img/dummy.png"));
var SimpleReactCropper = /** @class */ (function (_super) {
    __extends(SimpleReactCropper, _super);
    function SimpleReactCropper() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            src: dummy_png_1.default
        };
        _this._uploadToServer = function () {
            _this.cropper
                .getCroppedCanvas({
                width: _this.props.width || 500,
                height: _this.props.height || 500,
                minWidth: 0,
                minHeight: 0,
                maxWidth: 1024,
                maxHeight: 1024,
                fillColor: _this.props.fillColor || "#fff",
                imageSmoothingEnabled: true,
                imageSmoothingQuality: "high"
            })
                .toBlob(function (blob) {
                _this.props.upload(blob);
            });
            if (_this.props.afterCrop)
                _this.props.afterCrop();
        };
        _this._handleFileChange = function (e) {
            e.preventDefault();
            e.stopPropagation();
            var _a = e.target, validity = _a.validity, files = _a.files;
            if (validity.valid && files) {
                var reader_1 = new FileReader();
                reader_1.onload = function () {
                    _this.setState({ src: reader_1.result });
                    _this.cropper
                        .reset()
                        .clear()
                        .replace(reader_1.result);
                };
                reader_1.readAsDataURL(files[0]);
            }
        };
        return _this;
    }
    SimpleReactCropper.prototype.componentDidMount = function () {
        this.cropper = new cropperjs_1.default(this.img, {
            viewMode: 1,
            aspectRatio: this.props.aspectRatio,
            zoomable: false
        });
    };
    SimpleReactCropper.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement("div", { className: "container", style: this.props.containerStyle },
            react_1.default.createElement("div", { className: "container-img" },
                react_1.default.createElement("img", { ref: function (node) { return (_this.img = node); }, id: "avatar_img", src: this.state.src })),
            react_1.default.createElement("div", { style: {
                    display: "flex",
                    justifyContent: "space-between",
                    paddingTop: "1rem"
                } },
                react_1.default.createElement("input", { type: "file", id: "origin-image", name: "origin-image", className: "input-file", onChange: this._handleFileChange }),
                react_1.default.createElement("label", { htmlFor: "origin-image" }, "Choose a file"),
                react_1.default.createElement("button", { className: "button-save", onClick: this._uploadToServer }, "Save"))));
    };
    return SimpleReactCropper;
}(react_1.default.Component));
exports.default = SimpleReactCropper;
